# Search two ways, find a item in a list

numbers = [1,4,6518,14,3,5,6,324,65,1346,3476,18,56,456,38,39,93,22,555,334,6543,226,993,43516,13846,8734,668]
print("List:", numbers)

# Sequental search looks at each item
key = 555
iterations = 0
for i in numbers:
    iterations += 1
    if i == key:
        print("Item ", i, "found after", iterations, "iterations")

# Binary search with a sorted list
numbers.sort()      # Sorting the list takes CPU power
print("Sorted list:", numbers)

floor = 0                   # Initial searc range is whole list
top = len(numbers) - 1      # Remember that indexes start at 0
found = False
i = int(top/2)              # i is pointing to the middle of range through search
iterations = 0

# Halve the search area at each loop by moving the top and bottom limits
# and putting the search index in the middle
while not(found):
    iterations += 1
    if numbers[i] == key:   # Found it
        found = True        # End of loop
    elif numbers[i] < key:  # item is higher on the list
        floor = i
    else:                   # item is lower on the list
        top = i
    i = int((floor + top)/2)    # set i to new search point

print("Item", numbers[i], "found at index", i, "after", iterations, "iterations" )
