# Demonstration of how parameters are handled in Python function calls

def set_list(list):             # Function receives a reference to a list object
    list = ["A", "B", "C"]      # A new list is created and the variable "list"
                                # is set to point to the new list
    return list

def add_list(list):             # Function receives a reference to a list object
    list.append("D")            # An item is appended to the existing list,
                                # variable name keeps pointing to same object
    return list

my_list = ["E"]
print("Calling set_list, it returns", set_list(my_list))
print("my_list after call", my_list)
print("Calling add_list, it returns",add_list(my_list))
print("my_list after call", my_list)
